/* Copyright Statement:
 *
 * This software/firmware and related documentation ("AutoChips Software") are
 * protected under relevant copyright laws. The information contained herein is
 * confidential and proprietary to AutoChips Inc. and/or its licensors. Without
 * the prior written permission of AutoChips inc. and/or its licensors, any
 * reproduction, modification, use or disclosure of AutoChips Software, and
 * information contained herein, in whole or in part, shall be strictly
 * prohibited.
 *
 * AutoChips Inc. (C) 2024. All rights reserved.
 *
 * BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND AGREES
 * THAT THE SOFTWARE/FIRMWARE AND ITS DOCUMENTATIONS ("AUTOCHIPS SOFTWARE")
 * RECEIVED FROM AUTOCHIPS AND/OR ITS REPRESENTATIVES ARE PROVIDED TO RECEIVER
 * ON AN "AS-IS" BASIS ONLY. AUTOCHIPS EXPRESSLY DISCLAIMS ANY AND ALL
 * WARRANTIES, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
 * NONINFRINGEMENT. NEITHER DOES AUTOCHIPS PROVIDE ANY WARRANTY WHATSOEVER WITH
 * RESPECT TO THE SOFTWARE OF ANY THIRD PARTY WHICH MAY BE USED BY,
 * INCORPORATED IN, OR SUPPLIED WITH THE AUTOCHIPS SOFTWARE, AND RECEIVER AGREES
 * TO LOOK ONLY TO SUCH THIRD PARTY FOR ANY WARRANTY CLAIM RELATING THERETO.
 * RECEIVER EXPRESSLY ACKNOWLEDGES THAT IT IS RECEIVER'S SOLE RESPONSIBILITY TO
 * OBTAIN FROM ANY THIRD PARTY ALL PROPER LICENSES CONTAINED IN AUTOCHIPS
 * SOFTWARE. AUTOCHIPS SHALL ALSO NOT BE RESPONSIBLE FOR ANY AUTOCHIPS SOFTWARE
 * RELEASES MADE TO RECEIVER'S SPECIFICATION OR TO CONFORM TO A PARTICULAR
 * STANDARD OR OPEN FORUM. RECEIVER'S SOLE AND EXCLUSIVE REMEDY AND AUTOCHIPS'S
 * ENTIRE AND CUMULATIVE LIABILITY WITH RESPECT TO THE AUTOCHIPS SOFTWARE
 * RELEASED HEREUNDER WILL BE, AT AUTOCHIPS'S OPTION, TO REVISE OR REPLACE THE
 * AUTOCHIPS SOFTWARE AT ISSUE, OR REFUND ANY SOFTWARE LICENSE FEES OR SERVICE
 * CHARGE PAID BY RECEIVER TO AUTOCHIPS FOR SUCH AUTOCHIPS SOFTWARE AT ISSUE.
 */
/******************************************************************************
 * @version: V3.1.0  AC7840x  Demo
 ******************************************************************************/

 

#include "ac7840x.h"
#include "debugout_ac7840x.h"
#include "ckgen_hw.h"
#include "ckgen_drv.h"
#include "clock_config.h"
#include "port_hw.h"
#include "gpio_hw.h"
#include "gpio.h"
#include "osif.h"
#include "spm_drv.h"

/*!
 *例程说明：
 *1、demo板上电后，RGB会闪烁6S后熄灭，MCU会进入STOP1模式，按下NMI按键，MCU回到RUN模式，
 *RGB继续闪烁，6S后进入STOP1模式并熄灭，以此循环。
 *
 * 若使用AC7840X_LQFP144_100_COMMON_V1硬件板，需要添加宏定义“AC7840_BOARD_V0”，其他硬件板则不需要添加此宏
 */
 

/*!
 * @brief 时钟配置函数.
 *
 * @param[in] none
 *
 * @return none
 */
void SystemClock_Config(void)
{
    CKGEN_SYS_Init(g_clockManConfigsArr, CLOCK_MANAGER_CONFIG_CNT,
                   g_clockManCallbacksArr, CLOCK_MANAGER_CALLBACK_CNT);
    CKGEN_DRV_UpdateConfiguration(0, CLOCK_MANAGER_POLICY_AGREEMENT);
}

/*!
 * @brief NMI_Handler
 *        NMI中断回调函数
 * @param[in]  none
 *
 * @return none
 */
void NMI_Handler(void)
{

    printf("this is a nmi interrupt \r\n");

}
/*!
 * @brief NMI_Port_Init
 *        NMI引脚功能配置
 * @param[in]  none
 *
 * @return none
 */
void NMI_Port_Init(void)
{
    GPIO_DRV_SetMuxModeSel(PORTD,3,PORT_MUX_ALT7);
    GPIO_DRV_SetPullSel(PORTD,3,PORT_INTERNAL_PULL_UP_ENABLED);
}

/*!
 * @brief RGB_LED_TOGGLE
 *        RGB??
 * @param[in]  none
 *
 * @return none
 */
void RGB_LED_TOGGLE(void)
{

    OSIF_TimeDelay(200);
    RGBLED_R_ON;
    RGBLED_G_ON ;
    RGBLED_B_OFF;
    OSIF_TimeDelay(200);
    RGBLED_R_ON;
    RGBLED_G_OFF;
    RGBLED_B_ON;
    OSIF_TimeDelay(200);
    RGBLED_R_OFF;
    RGBLED_G_ON;
    RGBLED_B_ON;
}
/*!
 * @brief main
 *
 * @param[in]  none
 *
 * @return 0: success, other: error value
 */
int main()
{
    int flag = 0;
    SystemClock_Config();

    InitDebug();
    NMI_Port_Init();    /*!使能NMI引脚功能*/
    EnableNMI(1);       /*!使能NMI功能*/
    GPIO_LedInit();	    /*!初始化RGB引脚*/

    while(1)
    {
        flag++;
        RGB_LED_TOGGLE();
            
        if(flag>10)
        {
            RGBLED_R_OFF;
            RGBLED_G_OFF;
            RGBLED_B_OFF;
            SPM_DRV_SetPowerMode(POWER_MODE_STOP1); /*!MCU 进入stop1模式*/
            flag = 0;
        }
    }
}
